/*
 * File: app/controller/components/ReportScheduler.js
 *
 * This file was generated by Sencha Architect version 3.5.1.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('RepoScheduler.controller.components.ReportScheduler', {
    extend: 'Ext.app.Controller',
    alias: 'controller.components.reportscheduler',

    onCancelClick: function(button, e, eOpts) {
        this.backToList();
    },

    onAddClick: function(button, e, eOpts) {
        var me = this;
        var formController = this.getController('components.form.Form');
        var result = formController.retriveFormValues();
        var record = this.getStore('reports.ScheduledReports').findRecord('id', result.id);

        if (formController.formIsValid() && this.getController('components.contact.ContactList').getNumContactsSelected()) {
            this.getStore('reports.ScheduledReports').addRecord(result, function() {
                me.fireEvent('createMsgPopup', {
                    title: Ext.locale.translate('Report Scheduler'),
                    msg: Ext.locale.translate('Report scheduled'),
                    fn: function(res) {
                        me.backToList();
                    }
                });
                Ext.ComponentQuery.query('#reportschedulerlist')[0].getView().refresh();
            });
        }
    },

    init: function(application) {
                this.listen({
                    controller: {
                        '*': {
                            toggleAddButtonStatus: this.toggleAddButtonStatus,
                            toggleFooterButtonsStatus: this.toggleFooterButtonsStatus
                        }
                    }
                });

        this.control({
            "#reportscheduler #footer button#cancel": {
                click: this.onCancelClick
            },
            "#reportscheduler #footer button#add": {
                click: this.onAddClick
            }
        });
    },

    toggleAddButtonStatus: function(status) {
        var fn = status ? "enable" : "disable";

        Ext.ComponentQuery.query('#reportscheduler #footer button#add')[0][fn]();
    },

    toggleFooterButtonsStatus: function(status) {
        this.toggleAddButtonStatus(status);
    },

    backToList: function() {
        var formController = this.getController('components.form.Form');

        formController.clearForm();
        formController.changeInputsStatus('reports', 'enable');

        this.getController('components.contact.ContactList').selectContacts();

        this.fireEvent('schedActiveView', 'reportschedulerlist');
    }

});
