/*
 * File: app/controller/components/SchedulerList.js
 *
 * This file was generated by Sencha Architect version 3.5.1.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('RepoScheduler.controller.components.SchedulerList', {
    extend: 'Ext.app.Controller',
    alias: 'controller.components.schedulerlist',

    onAddClick: function(button, e, eOpts) {
        this.fireEvent('schedActiveView', 'reportscheduler');
    },

    onRemoveClick: function(button, e, eOpts) {
        var cmp = Ext.ComponentQuery.query('#reportschedulerlist')[0];
        var records = cmp.getSelectionModel().selected.items;

        if(! records.length){
            return this.fireEvent('createMsgPopup', {
                title: Ext.locale.translate('Alert'),
                msg: Ext.locale.translate('NoElementsSelectedMsg')
            });
        }

        this.fireEvent('removeScheduler', this.normalizeIds(records));
    },

    onReportschedulerActionClick: function(actioncolumn, el, rowIndx, colIndx, dom, record) {
        var target = dom.target.className.match(/.*ico-([^ ]+).*/);
        var me = this;

        if(target && target.length) {
            var fn = target[1];
            var functions = {edit: me.editRecord, clone: me.cloneRecord};

            functions[fn].call(me, record);
        }
    },

    normalizeIds: function(records) {
        return records.map(function(current) {
            return current.get('id');
        });
    },

    getSelectedItems: function() {
        return Ext.ComponentQuery.query('#reportschedulerlist')[0].getSelectionModel().selected.items;
    },

    getCountSelectedItems: function() {
        return this.getSelectedItems().length;
    },

    editRecord: function(record) {
        this.getController('components.form.Form').fillForm(record, true);
        this.fireEvent('schedActiveView', 'reportscheduler');
    },

    cloneRecord: function(record) {
        this.getController('components.form.Form').fillForm(record, false);
        this.fireEvent('schedActiveView', 'reportscheduler');
    },

    init: function(application) {
        this.control({
            "#reportschedulerlist #footer button#add": {
                click: this.onAddClick
            },
            "#reportschedulerlist #footer button#remove": {
                click: this.onRemoveClick
            },
            "#reportschedulerlist #reportschedulerAction": {
                click: this.onReportschedulerActionClick
            }
        });
    }

});
