/*
 * File: app/controller/components/form/Form.js
 *
 * This file was generated by Sencha Architect version 3.5.1.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('RepoScheduler.controller.components.form.Form', {
    extend: 'Ext.app.Controller',
    alias: 'controller.components.form.form',

    refs: [
        {
            ref: 'formCmp',
            selector: '#reportscheduler #form'
        }
    ],

    onFrequencyChange: function(field, newValue, oldValue, eOpts) {
        this.changeInputsStatus('weekly, once, monthly', 'hide, disable, setValue');
        this.changeInputsStatus(field.getValue(), 'enable, show, focus');
    },

    onFormValidityChange: function(basic, valid, eOpts) {
        var numContacts = this.getController('components.contact.ContactList').getNumContactsSelected();

        this.fireEvent('toggleFooterButtonsStatus', valid && numContacts);
    },

    changeInputsStatus: function(inputs, status) {
        if(inputs) {
            var me = this;
            var args = Array.prototype.slice.call(arguments, 2);
            var fns = status.split(',');

            me.getFormCmp().getForm().getFields().items
                .filter(function(item) {
                    return inputs.indexOf(item.itemId) !== -1;
                })
                .map(function(input) {
                    fns.forEach(function(fn) {
                        fn = fn.trim();

                        if (typeof input[fn] === 'function') {
                            input[fn].apply(input, args);
                        }
                    });
                });
        }
    },

    normalizeFormValues: function() {
        return this.getFormCmp().getForm().getFields().items.reduce(
            function(prev, curr) {
                prev[curr.name] = curr.getValue();
                return prev;
            }, {}
        );
    },

    normalizeContacts: function(contacts) {
        return contacts.map(function(contact) {
            return {contact_id: contact.get('contact_id')};
        });
    },

    normalizeReports: function(ids) {
        var store = this.getStore('reports.SavedReports');

        return ids.map(function(curr) {
            var record = store.findRecord('id', curr);
            var id = record.get('id');

            if(record.get('formTo') == 4) {
                id = id.replace('filter-', '');
            }

            return {
                report_id: id,
                report_type: record.get('formTo'),
                report_name: record.get('reportName')
            };
        });
    },

    transformContactsInRecords: function(contacts) {
        var store = this.getStore('contacts.Contacts');

        return RepoScheduler.helpers.Helper.convertObjToArr(contacts)
                .map(function(contact) {
                    return store.findRecord('contact_id', contact.contact_id, 0, false, false, true);
                });
    },

    formIsValid: function() {
        return this.getFormCmp().getForm().isValid();
    },

    retriveFormValues: function() {
        var formValues = this.normalizeFormValues();
        var contacts = this.normalizeContacts(this.getController('components.contact.ContactList').getContactsSelected());
        var reports = this.normalizeReports(formValues.reports);

        return Ext.apply(formValues, {
            reports: reports,
            contacts: contacts
        });
    },

    fillForm: function(rec, isEdit) {
        var inputs = { monthly: "monthDay", weekly: "weekDay", once: "date" };

        if(rec.get('report_type') !== '4') {
            this.changeInputsStatus('reports', 'setValue', rec.get('report_id'));
        }
        else {
            this.changeInputsStatus('reports', 'setValue', 'filter-' + rec.get('report_id'));
        }

        this.changeInputsStatus('frequency', 'setValue', rec.get('frequency'));
        this.changeInputsStatus('hour', 'setValue', rec.get('hour'));
        this.changeInputsStatus(rec.get('frequency'), 'enable, setValue', rec.get(inputs[rec.get('frequency')]));

        this.getController('components.contact.ContactList').selectContacts(this.transformContactsInRecords(rec.get('contacts')));

        if(isEdit) {
            this.changeInputsStatus('reports', 'disable');
            this.changeInputsStatus('id', 'setValue', rec.get('id'));
        }
        else {
            this.changeInputsStatus('reports', 'enable');
        }
    },

    clearForm: function() {
        return this.getFormCmp().getForm().reset();
    },

    getReportName: function(rec) {
        return RepoScheduler.helpers.Helper.convertObjToArr(rec.get('reports'))
                .map(function(report) {
                    return report.name;
                })[0];
    },

    init: function(application) {
        this.control({
            "#frequency": {
                change: this.onFrequencyChange
            },
            "#form": {
                validitychange: this.onFormValidityChange
            }
        });
    }

});
