/*
 * File: app/store/reports/ScheduledReports.js
 *
 * This file was generated by Sencha Architect version 3.5.1.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('RepoScheduler.store.reports.ScheduledReports', {
    extend: 'Ext.data.Store',

    requires: [
        'RepoScheduler.model.report.ScheduledReport',
        'Ext.data.proxy.Ajax',
        'Ext.data.reader.Json'
    ],

    constructor: function(cfg) {
        var me = this;
        cfg = cfg || {};
        me.callParent([Ext.apply({
            autoLoad: true,
            model: 'RepoScheduler.model.report.ScheduledReport',
            storeId: 'reports.ScheduledReports',
            proxy: {
                type: 'ajax',
                url: '/opmon/seagull/www/index.php/reportscheduler/action/get_all_schedule/',
                headers: {
                    'X-Requested-With': 'XMLHttpRequest'
                },
                reader: {
                    type: 'json',
                    root: 'data'
                }
            },
            listeners: {
                datachanged: {
                    fn: me.onJsonstoreDataChangeD,
                    scope: me
                }
            }
        }, cfg)]);
    },

    onJsonstoreDataChangeD: function(store, eOpts) {
        var total = Ext.ComponentQuery.query('#reportschedulerlist displayfield#total')[0];

        total.setValue(store.getCount() + ' ' + total.getValue().replace(/\d*/g, ''));
    },

    normalizeIds: function(ids) {
        var me = this;

        return ids.map(function(id) {
            return me.findRecord('id', id);
        });
    },

    setNumberUsers: function(record, saved) {
        var number = saved.filter(function(s) {
            return s.data.reportName === record.data.reportName;
        })
            .map(function(report) {
                return Object.keys(report.data.scheduled.contacts).map(function(key) {
                    return report.data.scheduled.contacts[key];
                });
            })[0].length;

        record.set('numberUsers', number);
    },

    addRecord: function(result, callback) {
        var me = this;

        if(result.date) {
            result.date = result.date.getFullYear() + '-' + (result.date.getMonth() + 1) + '-' + result.date.getDate();
        }

        delete result.report_id;

        var toStore = Ext.clone(result);
        var updateStoreObj = toStore.reports.map(function(curr) {
            var fresh = Ext.clone(toStore);
            delete fresh.reports;
            return Ext.apply(curr, fresh);
        });

        var p = Ext.apply(
            {
                data: Ext.JSON.encode(result)
            },
            {
                hostServiceProtocol: "https",
                mod: "RSCHED"
            }
        );

        Ext.Ajax.request({
            url: '/opmon/seagull/www/index.php/reportscheduler/action/scheduler/',
            params: p,
            method: "POST",
            headers: {
                'X-Requested-With': 'XMLHttpRequest'
            },
            success: function(conn, res) {
                me.load({
                    callback: callback
                });
            }
        });
    },

    removeRecord: function(ids, callback) {
        var me = this;

        Ext.Ajax.request({
            url: '/opmon/seagull/www/index.php/reportscheduler/action/unscheduler/',
            params: { id: Ext.JSON.encode(ids), hostServiceProtocol: 'https', mod: 'RSCHED' },
            headers: {
                'X-Requested-With': 'XMLHttpRequest'
            },
            success: function() {
                me.remove(me.normalizeIds(ids));
                me.sync();
                callback(null);
            },
            fail: callback.bind(me)
        });
    }

});