/*
 * File: app/view/components/ReportList.js
 *
 * This file was generated by Sencha Architect version 3.5.1.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('RepoScheduler.view.components.ReportList', {
    extend: 'Ext.grid.Panel',
    alias: 'widget.components.reportlist',

    requires: [
        'Ext.grid.column.Template',
        'Ext.XTemplate',
        'Ext.grid.column.Action',
        'Ext.grid.View',
        'Ext.selection.CheckboxModel',
        'Ext.toolbar.Toolbar',
        'Ext.form.field.Display',
        'Ext.button.Button'
    ],

    store: 'reports.ScheduledReports',

    initComponent: function() {
        var me = this;

        Ext.applyIf(me, {
            columns: [
                {
                    xtype: 'templatecolumn',
                    itemId: 'type',
                    maxWidth: 150,
                    tpl: [
                        '<tpl>',
                        '    <tpl if="report_type == 0">'+Ext.locale.translate('Availability')+'</tpl>',
                        '    <tpl if="report_type == 1">'+Ext.locale.translate('Capacity')+'</tpl>',
                        '    <tpl if="report_type == 3">'+Ext.locale.translate('SLM')+'</tpl>',
                        '    <tpl if="report_type == 4">'+Ext.locale.translate('Filters')+'</tpl>',
                        '</tpl>'
                    ],
                    width: 150,
                    dataIndex: 'formTo',
                    text: Ext.locale.translate('Report Type'),
                    tooltip: Ext.locale.translate('Report Type')
                },
                {
                    xtype: 'gridcolumn',
                    itemId: 'name',
                    dataIndex: 'report_name',
                    text: Ext.locale.translate('Report Name'),
                    tooltip: Ext.locale.translate('Report Name'),
                    flex: 1
                },
                {
                    xtype: 'gridcolumn',
                    itemId: 'periodicity',
                    width: 250,
                    dataIndex: 'periodicity',
                    text: Ext.locale.translate('Periodicity'),
                    tooltip: Ext.locale.translate('Periodicity')
                },
                {
                    xtype: 'gridcolumn',
                    itemId: 'numberUsers',
                    width: 78,
                    dataIndex: 'numberUsers',
                    text: Ext.locale.translate('Users'),
                    tooltip: Ext.locale.translate('Number of users')
                },
                {
                    xtype: 'actioncolumn',
                    itemId: 'reportschedulerAction',
                    width: 45,
                    items: [
                        {
                            icon: 'resources/ico-editar-duplicar.png',
                            iconCls: 'ico-clone',
                            tooltip: Ext.locale.translate('Clone')
                        },
                        {
                            icon: 'resources/ico-editar.png',
                            iconCls: 'ico-edit',
                            tooltip: Ext.locale.translate('Edit')
                        }
                    ]
                }
            ],
            viewConfig: {
                itemId: 'reportschedulerList'
            },
            selModel: Ext.create('Ext.selection.CheckboxModel', {

            }),
            dockedItems: [
                {
                    xtype: 'toolbar',
                    dock: 'top',
                    itemId: 'header',
                    layout: {
                        type: 'hbox',
                        padding: '0 5'
                    },
                    items: [
                        {
                            xtype: 'displayfield',
                            itemId: 'total',
                            value: Ext.locale.translate('scheduled reports')
                        }
                    ]
                },
                {
                    xtype: 'toolbar',
                    dock: 'bottom',
                    itemId: 'footer',
                    items: [
                        {
                            xtype: 'button',
                            itemId: 'add',
                            text: Ext.locale.translate('Add')
                        },
                        {
                            xtype: 'button',
                            itemId: 'remove',
                            text: Ext.locale.translate('Remove')
                        }
                    ]
                }
            ]
        });

        me.callParent(arguments);
    }

});