(function()
{
    
    var weekdays =
           ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
    
    Ext.define('RepoScheduler.helpers.Helper', {

        statics: {
            capitalizeFirstLetter: function(str) {
                return str.slice(0,1).toUpperCase() +
                    str.slice(1, str.length);
            },
            
            convertWeekday: function(num) {
                return weekdays[num] || null;
            },
            
            convertObjToArr: function(obj) {
                if(obj) {
                    return Object.keys(obj).map(function(k) {
                        return obj[k];
                    });
                }
                return [];
            },

            runAComponentFn: function(components, fn) {
                var args = Array.prototype.slice.call(arguments, 2);
                
                components = privateIsArray(components);

                return components.map(function(query) {
                    var component = Ext.ComponentQuery.query(query);
                    var result;
                    if(component && component[fn]) {
                        result = component[fn].apply(component, args);
                    }
                    return {
                        cmp: component,
                        result: result
                    };
                });
            },
            
            addSchedulerType: function(records) {
                if(records) {
                    var store = Ext.getStore('SchedTypes');
                    
                    records.forEach(function(record) {
                        var typeRec = store.findRecord('id', record.get('formTo'));
                        typeRec.get('reports').push(record.data);
                    });
                }
            }
        }

    });
    
    function privateIsArray(obj) {
        return obj instanceof Array ? obj : [obj];
    }
    
})();
