(
    function()
    {
        // The component

        var component = Ext.define('RepoScheduler.view.helpers.components.BoxSelect', {
            extend: 'Ext.ux.form.field.BoxSelect',
            alias: 'widget.helpers.components.boxselect',

            requires: [
                'Ext.view.BoundList',
                'Ext.XTemplate'
            ],

            anyMatch: true,
            displayField: 'reportName',
            forceSelection: true,
            multiSelect: true,
            queryMode: 'local',
            store: 'reports.SavedReports',
            valueField: 'id',
            stacked: true,

            initComponent: function() {
                var me = this;

                Ext.applyIf(me, {
                    listConfig: {
                        xtype: 'boundlist',
                        tpl: new listTemplate()
                    },
                    listeners: {
                        expand: {
                            fn: function() {
                                var me = this;
                                document.querySelector('.x-list-plain').addEventListener('click', function(event) {
                                    if(event.target.className.indexOf('x-grid-group-title') >= 0) {
                                        event.stopPropagation();
                                    }
                                });
                            },
                            scope: me
                        }
                    }
                });

                me.callParent(arguments);
            }
        });



        // Template
        // Generate a template used in BoxSelect to create the body

        var listTemplate = function() {
            var types = { 
                '0': Ext.locale.translate('Availability'),
                '1': Ext.locale.translate('Capacity'),
                '3': Ext.locale.translate('SLM'),
                '4': Ext.locale.translate('Filters'),
                'default': Ext.locale.translate('Other')
            };

            var template = '{[this.currentFormTo = null]}'                                                                                                  
            + '<ul class="x-list-plain">'                                                                                                      
            + '    <tpl for=".">'                                                                                                              
            + '        <tpl if="this.shouldShowHeader(formTo)">'
            + '            <li class="x-grid-group-hd x-grid-group-title">{[this.showHeader()]}</li>'
            + '        </tpl>'                                                                                                                 
            + '        <li class="x-boundlist-item"><span>{reportName}</span></li>'
            + '     </tpl>'                                                                                                                    
            + '</ul>';

            function fnShouldShowHeader(formTo) {
                var result = this.currentFormTo != formTo;
                this.currentFormTo = formTo;
                return result;
            }

            function fnShowHeader(formTo) {
                var key = this.currentFormTo.toString();

                return types.hasOwnProperty(key) ? types[key] : types['default'];
            }

            return Ext.create('Ext.XTemplate', template, {
                shouldShowHeader: fnShouldShowHeader.bind(this),
                showHeader: fnShowHeader.bind(this)
            });
        };

    }
)();